/*------------------------------------------------------*
 |  The Shakespeare Insulter                            |
 |  modified and re-compiled with IBM VAC++ V4.0 from   |
 |  unknown PERL author to OS/2 by Erick Andrews,       |
 |  3-APR-2000                                          |
 *------------------------------------------------------*
 |  This program generates an insult by randomly        |
 |  selecting two adjectives and a noun from a list of  |
 |  perjorative words found within the works of the     |
 |  Bard of Avon.                                       |
 *------------------------------------------------------*
 |  Anyone can use this source to do whatever they want |
 *------------------------------------------------------*/
#include   <stdio.h>
#include  <string.h>
#include  <stdlib.h>
#include   <ctype.h>
#include    <time.h>
/*------------------------------------------------------*
 | Select a word from the space (' ') delimited list of |
 | words and place the result in the "dest" argument.   |
 | Return 1 if the function was successful, otherwise   |
 | zero.                                                |
 *------------------------------------------------------*/
int aword( char *list, char *dest )
{
    int i;
    int start = -1;
    /*
    ** select a random starting point
    */
    for( i = rand() % strlen( list ); list[ i ]; i++ ) {
         if( list[ i ] == ' ' ) {
             start = i;
             break;
         }
    }
    /*
    **  start points to a space
    */
    if( start < 0 ) {
        start = 0;
    }
    ++start;
    /*
    ** load up the selected word

    */
    while( 1 ) {
           *dest = list[ start ];
           switch( *dest ) {
                   case 0:
                        return( 1 );
                   case ' ':
                        *dest = 0;
                        return( 1 );
           }
           ++dest;
           ++start;
           if( start > (int)strlen( list ) ) {
               return( 0 );
           }
    }
    return( 0 );
}
/*------------------------------------------------------*
 |  Program entry point.                                |
 *------------------------------------------------------*/
int main( int argc, char *argv[] )
{
    extern char *Adj1;
    extern char *Adj2;
    extern char *Noun;
    char word1[ 32 ];
    char word2[ 32 ];
    char word3[ 32 ];
    /*
    **  variable to control how many insults are needed
    */
    int count = 1;
    /*
    **  handle the ANSI X11J16 compilers
    */
    argc = argc;
    argv = argv;
    /*
    **  generate a sequence of random numbers
    */
    srand( (unsigned)time( NULL ) );
    while( count-- ) {
           if( aword( Adj1, word1 ) ) {
               if( aword( Adj2, word2 ) ) {
                   if( aword( Noun, word3 ) ) {
                       fprintf( stdout, "Thou %s, %s %s!!\n", word1, word2, word3 );
                   }
               }
           }
    }
    return( 0 );
}
/*------------------------------------------------------*
 | These are the lists of words                         |
 *------------------------------------------------------*/
char *Adj1 = " artless bawdy beslubbering bootless churlish cockered clouted craven currish dankish dissembling droning errant fawning fobbing froward frothy gleeking goatish gorbellied impertinent infectious jarring loggerheaded lumpish mammering mangled mewling paunchy pribbling puking puny quailing rank reeky roguish ruttish saucy spleeny spongy surly tottering unmuzzled vain venomed villainous warped wayward weedy yeasty";

char *Adj2 = " base-court bat-fowling beef-witted beetle-headed boil-brained clapper-clawed clay-brained common-kissing crook-pated dismal-dreaming dizzy-eyed doghearted dread-bolted earth-vexing elf-skinned fat-kidneyed fen-sucked flap-mouthed fly-bitten folly-fallen fool-born full-gorged guts-griping half-faced hasty-witted hedge-born hell-hated idle-headed ill-breeding ill-nurtured knotty-pated milk-livered motley-minded onion-eyed plume-plucked pottle-deep pox-marked reeling-ripe rough-hewn rude-growing rump-fed shard-borne sheep-biting spur-galled swag-bellied tardy-gaited tickle-brained toad-spotted unchin-snouted weather-bitten";

char *Noun = " apple-john baggage barnacle bladder boar-pig bugbear bum-bailey canker-blossom clack-dish clotpole coxcomb codpiece death-token dewberry flap-dragon flax-wench flirt-gill foot-licker fustilarian giglet gudgeon haggard harpy hedge-pig horn-beast hugger-mugger jolthead lewdster lout maggot-pie malt-worm mammet measle minnow miscreant moldwarp mumble-news nut-hook pigeon-egg pignut puttock pumpion ratsbane scut skainsmate strumpet varlot vassal whey-face wagtail";
/*------------------------------------------------------|
 | End of module                                        |
 *------------------------------------------------------*/


